about summary refs log tree commit diff stats
path: root/modules/by-name/xd/xdg/lf-wrapper.sh
diff options
context:
space:
mode:
Diffstat (limited to '')
-rwxr-xr-xmodules/by-name/xd/xdg/lf-wrapper.sh39
1 files changed, 39 insertions, 0 deletions
diff --git a/modules/by-name/xd/xdg/lf-wrapper.sh b/modules/by-name/xd/xdg/lf-wrapper.sh
new file mode 100755
index 00000000..f85f7bac
--- /dev/null
+++ b/modules/by-name/xd/xdg/lf-wrapper.sh
@@ -0,0 +1,39 @@
+#!/usr/bin/env sh
+# This wrapper script is invoked by xdg-desktop-portal-termfilechooser.
+#
+# For more information about input/output arguments read `xdg-desktop-portal-termfilechooser(5)`
+
+set -ex
+
+multiple="$1"
+directory="$2"
+save="$3"
+path="$4"
+out="$5"
+
+# echo > /tmp/stdout
+# echo > /tmp/stderr
+#
+# exec 1>> /tmp/stdout
+# exec 2>> /tmp/stderr
+
+if [ "$save" = "1" ]; then
+    # save a file
+    set -- -selection-path="$out" -command='set promptfmt "Select the file to write to %S \033[32;1m%u@%h\033[0m:\033[34;1m%d\033[0m\033[1m%f\033[0m"' "$path"
+elif [ "$directory" = "1" ]; then
+    # upload files from a directory
+    set -- -last-dir-path="$out" -command='set dironly' -command='set promptfmt "Select directory (quit in dir to select it) %S \033[32;1m%u@%h\033[0m:\033[34;1m%d\033[0m\033[1m%f\033[0m"' "$path"
+elif [ "$multiple" = "1" ]; then
+    # upload multiple files
+    set -- -selection-path="$out" -command='set promptfmt "Select file(s) (open file to select it; <Space> to select multiple) %S \033[32;1m%u@%h\033[0m:\033[34;1m%d\033[0m\033[1m%f\033[0m"' "$path"
+else
+    # upload only 1 file
+    set -- -selection-path="$out" -command='set promptfmt "Select file (open file to select it) %S \033[32;1m%u@%h\033[0m:\033[34;1m%d\033[0m\033[1m%f\033[0m"' "$path"
+fi
+
+alacritty --title 'floating please' -e lf "$@"
+
+# Delete the left recommended file, if we did not actually save anything.
+if [ "$save" = "1" ] && ! [ -s "$out" ]; then
+    rm "$path"
+fi